import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;


/**
 * Eine Gruppe als Kompositum
 * 
 * @author Claus Albowski
 * @version (20.05.07)
 */
public class Gruppe extends Moebel
{
  ArrayList<Moebel> moebelListe;
  

    /**
     * Erzeuge eine neue Gruppe.
     */
    public Gruppe(int x, int y, String f, int o) {
        xPosition = x; yPosition = y;
        farbe = f; istSichtbar = false;
        orientierung = o; breite = 0; tiefe  = 0;
        moebelListe = new ArrayList<Moebel>();
    }
  
    /**
     * Erzeuge eine neue Gruppe mit Standardwerten.
     */
    public Gruppe() {
        xPosition = 0; yPosition = 0;
        farbe = "blau"; istSichtbar = false;
        orientierung = 0; breite = 0; tiefe  = 0;
        moebelListe = new ArrayList<Moebel>();
    }
  
    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
     */
    protected Shape gibAktuelleFigur()
    {
        GeneralPath gruppe = new GeneralPath();
        for (int i=0;i<moebelListe.size();i++)
        gruppe.append((moebelListe.get(i)).gibAktuelleFigur(), false);
        return  transformiere(gruppe);
    }
    
    /**
     * aktualisiert breite und tiefe.
     */
    private void aktualisiereBreiteTiefe(){
        Rectangle2D umriss = gibAktuelleFigur().getBounds2D();
        breite=(int)umriss.getX();
        tiefe=(int)umriss.getY();
    }
    
    
    // die eigentlichen Kompositum - Methoden
  
    /**
     * fgt ein Mbel der Gruppe hinzu.
     */
    public void fuegeHinzu(Moebel moebel){
        moebelListe.add(moebel);
        aktualisiereBreiteTiefe();
    }
    
    /**
     * entfernt ein Mbel aus der Gruppe.
     */
    public void entferneMoebel(Moebel moebel){
        if (moebelListe.contains(moebel)){
            moebelListe.remove(moebel);
            aktualisiereBreiteTiefe();
        }
    }
    
    /**
     * sucht das i-te Mbel aus der Gruppe heraus;
     * gibt null zurck wenn es kein i-tes gibt.
     */
    public Moebel gibMoebel(int i){
        if ((i>-1)&&(i<moebelListe.size())) return moebelListe.get(i);
        else return null;
    }
        
    // Auswahlmethoden fr spezielle Mbel rufen jeweisl nur die Konstruktoren auf.
    // Dies gehrt eigentlich nicht in diese Klasse.
    
    /**
     * gibt einen neuen Tisch zurck.
     */
    public Moebel neuerTisch(int x,int y,String f,int o,int b,int t){
        return new Tisch(x, y, f, o, b, t);
    }
    
    /**
     * gibt einen neuen Stuhl zurck.
     */
    public Moebel neuerStuhl(int x,int y,String f,int o,int b,int t){
        return new Stuhl(x, y, f, o, b, t);
    }
    
    /**
     * gibt einen neuen Schrank zurck.
     */
    public Moebel neuerSchrank(int x,int y,String f,int o,int b,int t){
        return new Schrank(x, y, f, o, b, t);
    }
    
    /**
     * gibt ein neues Bett zurck.
     */
    public Moebel neuesBett(int x,int y,String f,int o,int b,int t){
        return new Bett(x, y, f, o, b, t);
    }
    
    /**
     * gibt eine neue Gruppe zurck.
     */
    public Moebel neueGruppe(int x,int y,String f,int o){
        return new Gruppe(x, y, f, o);
    }
}
